import React from 'react';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    if (typeof b !== "function" && b !== null)
        throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

var WrapperLayers = /** @class */ (function (_super) {
    __extends(WrapperLayers, _super);
    function WrapperLayers(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            left: 0,
            y: 0,
            activeLayer: 0
        };
        _this.layers = {};
        _this.onMouseLeave = _this.onMouseLeave.bind(_this);
        return _this;
    }
    WrapperLayers.prototype.componentDidMount = function () {
        /*for (let key in this.layers) {
          const domEl = ReactDOM.findDOMNode(this.layers[key]);
          const domQueried = this.layers[key].props.selector ? domEl.querySelector(this.layers[key].props.selector) : domEl;
    
          domQueried.addEventListener(this.layers[key].props.event, this.eventOnLayer.bind(this, key, this.layers[key]));
        }*/
    };
    WrapperLayers.prototype.render = function () {
        return null;
        /*const childrenOrdered = React.Children.toArray(this.props.children).sort((a, b) => a.props.z - b.props.z);
        const wrapperStyle = this.getWrapperStyle();
    
        return (
          <div
            style={wrapperStyle}
            onMouseLeave={this.onMouseLeave}
            className="reactEventLayer"
          >
            {childrenOrdered.map((item, i) => {
              const childProps = {
                ref: (input: any) => { this.layers[`layer${i}`] = input },
                ...item.props
              };
              const clonedChild = React.cloneElement(
                item,
                childProps
              );
              const animRequested = item.props.animation;
              const { defaultStyle, activeStyle, nonActiveStyle, anim } = getAnimation(animRequested);
              const customStyle = this.controlEnterMode(i) ? activeStyle : nonActiveStyle;
    
              return (
                <div key={item.props.z} style={defaultStyle} style={customStyle}>
                  {(currStyle) => {
                    // children is a callback which should accept the current value of style
                    const styleLayer = i === 0 ? {
                      position: 'relative'
                    } : anim(currStyle);
    
                    return (<div className="wrapperLayer" style={styleLayer}>
                      {clonedChild}
                    </div>);
                  }}
                </div>
              )
            })}
          </div>
        );*/
    };
    /**
     * Number of the layer
     *
     * @returns {Number}
     */
    WrapperLayers.prototype.countLayer = function () {
        return Object.keys(this.layers).length;
    };
    /**
     * Event. Event attached to the eventListener and change the state.
     *
     * @param ref
     */
    WrapperLayers.prototype.eventOnLayer = function (ref) {
        var intLayer = parseInt(ref.replace('layer', '')), nextLayer = intLayer + 1;
        if (this.countLayer() > nextLayer)
            this.setState({ activeLayer: nextLayer });
    };
    /**
     *
     *
     * @param row
     * @returns {boolean}
     */
    WrapperLayers.prototype.controlEnterMode = function (row) {
        if (this.props.enterMode === 'replace') {
            return row === 0 || row === this.state.activeLayer;
        }
        if (this.props.enterMode === 'push') {
            return row === 0 || row <= this.state.activeLayer;
        }
    };
    /**
     * Do merge between the object passed and the obligatory styles
     *
     * @returns {{width: number}}
     */
    WrapperLayers.prototype.getWrapperStyle = function () {
        return __assign({ position: 'relative', overflow: 'hidden', display: 'inline-block' }, this.props.style);
    };
    /**
     * Event.
     * When i leave the wrapper, it return to the layer 0
     */
    WrapperLayers.prototype.onMouseLeave = function () {
        this.setState({ activeLayer: 0 });
    };
    return WrapperLayers;
}(React.Component));

var Layer = /** @class */ (function (_super) {
    __extends(Layer, _super);
    function Layer(props) {
        return _super.call(this, props) || this;
    }
    Layer.prototype.render = function () {
        return (React.createElement("div", { className: "layer", style: this.props.style }, this.props.children));
    };
    return Layer;
}(React.Component));

var index = {
    WrapperLayers: WrapperLayers,
    Layer: Layer
};

export { index as default };
//# sourceMappingURL=index.esm.js.map
